<?php


require_once __DIR__.'/../../main/inc/global.inc.php';


if (api_is_anonymous()) {
    exit;
}

Display::display_header('','');

$url = '';
$form = new FormValidator(
    '','post',$url,null,
    ['enctype' => 'multipart/form-data']
);

$lstQuiz = [];

if (isset($_GET['cidReq'])) {
    $codeCourse = $_GET['cidReq'];
    $form->validate();    
    $lstQuiz = getlstQuizArray($codeCourse);
}

$tableMenu = '<div class="col-md-12">';
foreach ($lstQuiz as &$quizObj ) {
    $idQ = $quizObj['id'];
    $tableMenu .= '<p class="titlemaincollab" > TITRE DU QUIZ : '.$quizObj['title'].'</p>';
    $myuserid = api_get_user_id();
    $idcollab = findAQuizCorrection($myuserid,$idQ);
    if ($idcollab==0) {

        $lstMyQuiz = getlstQuizFree($myuserid,$idQ,false);
        // Array Count
        if ( count($lstMyQuiz)==0 ) {
            
            $tableMenu .= '<a class="collabdocumentattemps" ';
            $tableMenu .= ' onClick="alert(\'Pour pouvoir corriger un travail, il faut avoir réalisé le travail.\');" ';
            $tableMenu .= '><div class="collablabel" >';
            $tableMenu .= 'Non disponible !';
            $tableMenu .= '</div>';
            $tableMenu .= '</a>';

        } else {

            $lstQuizFree = getlstQuizFree($myuserid,$idQ);

            foreach ($lstQuizFree as &$quizFreeObj ) {
                $tableMenu .= '<a class="collabdocument" ';
                $tableMenu .= ' onClick="return confirm(\'Etes-vous sûr de vouloir corriger ce quiz ?\');" ';
                $tableMenu .= ' href="'.api_get_path(WEB_PLUGIN_PATH).'collabgrade/funelcollab.php?cidReq=';
                $tableMenu .= $codeCourse.'&id_session='.$quizFreeObj['session_id'].'&refquiz='.$idQ;
                $tableMenu .= '&idQuiz='.$quizFreeObj['exe_id'].'&idStudent='.$quizFreeObj['user_id'].'&title='.$quizObj['title'].'" ';
                $tableMenu .= '><div class="collablabel" >';
                $tableMenu .= cryptUserName($quizFreeObj['username']);
                $tableMenu .= '</div>';
                $tableMenu .= '</a>';
            }

        }


    } else {
        $tableMenu .= '<a class="collabdocumentcheck" >';
        $tableMenu .= '<div class="collablabel" >';
        $tableMenu .= 'Correction faite';
        $tableMenu .= '</div>';
        $tableMenu .= '</a>';
    }
}
$tableMenu .= '</div>';

$tableMenu .= '<link rel="stylesheet" ';
$tableMenu .= ' href="'.api_get_path(WEB_PLUGIN_PATH).'collabgrade/resources/css/collabgrade.css" >';

$form->addHtml($tableMenu);
        
unset($_SESSION["collabgrade"]);

$content = $form->returnForm();

echo $content;

Display::display_footer();

function findAQuizCorrection($bossId,$idquiz) 
{

    $collabid = 0;
    $sqlSelect = "SELECT id FROM plugin_collabgrade ";
    $sqlSelect .= "WHERE id_author = $bossId ";
    $sqlSelect .= "AND exe_exo_id = $idquiz ";
    $resultSelect = Database::query($sqlSelect);
    while ($row = Database::fetch_array($resultSelect)) {
        $collabid = $row['id'];
    }
    return $collabid;

}

function getlstQuizFree($userid,$idquiz,$other = true) 
{

    // track_e_exercises
    $tblTrack = Database::get_main_table(TABLE_STATISTIC_TRACK_E_EXERCISES);
    $tblUsers = Database::get_main_table(TABLE_MAIN_USER);
    
    $sql = " SELECT users.username , track_e.exe_id , track_e.exe_user_id , track_e.exe_date , track_e.session_id FROM  $tblTrack track_e ";
    $sql .= " INNER JOIN $tblUsers as users ON exe_user_id = users.id ";    
    $sql .= " WHERE  track_e.exe_exo_id = $idquiz AND exe_result = 0 ";
    if ($other==true) {
        $sql .= " AND track_e.exe_user_id <> $userid ";
    } else {
        $sql .= " AND track_e.exe_user_id = $userid ";
    }
    $sql .= " LIMIT 1 ";
    
    // echo $sql.'<br>';
    
    $resultUser = [];

    $result = Database::query($sql);

    while ($row = Database::fetch_array($result)) {
        $exeid = $row['exe_user_id'];
        $resultUser[$exeid]  = array(
            'exe_id' => $row['exe_id'],
			'username' => $row['username'],
			'user_id' => $row['exe_user_id'],
            'session_id' => $row['session_id']
		);
    }

    return $resultUser;

}

function getlstQuizArray($codeCourse) 
{

    $tblCourse = Database::get_course_table(TABLE_MAIN_COURSE);
    $tblCourse = 'course';
    $tblQuizTest = Database::get_course_table(TABLE_QUIZ_TEST);

    $sqlC = " SELECT q.iid as id , q.title FROM $tblQuizTest as q ";
    $sqlC .= " INNER JOIN  $tblCourse as c ";
    $sqlC .= " ON q.c_id = c.id ";
    $sqlC .= " WHERE c.code LIKE '$codeCourse' ";

    $result = [];
    $resultC = Database::query($sqlC);
    while ($row = Database::fetch_array($resultC)) {
		$lpid = $row['id'];
		$result[$lpid] = array(
			'title' => $row['title'],
			'id' => $row['id']
		);
	}
    return $result;

}

// Replace all letter by other letter
function cryptUserName($username) {

    $username = str_replace(' ','',$username);
    $username = str_replace('-','',$username);
    $username = str_replace('_','',$username);

    $username = str_replace('a','z',$username);
    $username = str_replace('b','y',$username);
    $username = str_replace('c','x',$username);
    $username = str_replace('d','w',$username);
    $username = str_replace('e','v',$username);
    $username = str_replace('f','u',$username);
    $username = str_replace('g','t',$username);
    $username = str_replace('h','s',$username);
    $username = str_replace('i','r',$username);
    $username = str_replace('j','q',$username);
    $username = str_replace('k','p',$username);
    $username = str_replace('l','o',$username);
    $username = str_replace('m','n',$username);
    $username = str_replace('n','m',$username);
    $username = str_replace('o','l',$username);
    $username = str_replace('p','k',$username);
    $username = str_replace('q','j',$username);
    $username = str_replace('r','i',$username);
    $username = str_replace('s','h',$username);
    $username = str_replace('t','g',$username);
    $username = str_replace('u','f',$username);
    $username = str_replace('v','e',$username);
    $username = str_replace('w','d',$username);
    $username = str_replace('x','c',$username);
    $username = str_replace('y','b',$username);
    $username = str_replace('z','a',$username);

    $username = 'bap'.$username;

    return $username;

}
